using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace FormulasInGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(96, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(336, 280);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "GridDataBoundGrid with Formula Support";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private ArrayList formulaTags;
		private DataTable dt;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			dt = new DataTable("MyTable");
			
			int nRows = 10;
			dt.Columns.Add(new DataColumn("Col1", typeof(double)));
			dt.Columns.Add(new DataColumn("Col2", typeof(double)));
			dt.Columns.Add(new DataColumn("FormulaColumn", typeof(string)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = (double) (2 * i);
				dr[1] = (double) i;
				dt.Rows.Add(dr);
			}
			this.gridDataBoundGrid1.DataSource = dt;
			
			this.gridDataBoundGrid1.EnableAddNew = false;
            
			//Maintain formulaTags for the cells
			formulaTags = new ArrayList();

			for(int i = 0; i <= dt.Rows.Count + 1; ++i)
			{
				formulaTags.Add(null);
			}
			this.gridDataBoundGrid1.Model.ColWidths[3]=150;
          
            this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
            this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(GridSaveCellInfo);
          
            
		}

      
		
		private void GridSaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex <= dt.Rows.Count)
			{
				formulaTags[e.RowIndex - 1] = e.Style.FormulaTag;
				e.Handled = true;
			}
            if (this.gridDataBoundGrid1.Binder.IsAnyDirtyField())
                this.gridDataBoundGrid1.Binder.EndEdit();
		}

		private void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex == 3 && e.RowIndex > 0 && e.RowIndex <= dt.Rows.Count)
			{
				e.Style.CellType = "FormulaCell";
				e.Style.Text = string.Format("=({0}{1} + {2}{1}) / 2", GridRangeInfo.GetAlphaLabel(1), GridRangeInfo.GetNumericLabel(e.RowIndex),GridRangeInfo.GetAlphaLabel(2)); 
				e.Style.FormulaTag = (GridFormulaTag) this.formulaTags[e.RowIndex - 1];
				e.Handled = true;
			}
		}
	}
}